-- --------------------------------------------------------
-- Host:                         127.0.0.1
-- Server version:               5.5.23 - MySQL Community Server (GPL)
-- Server OS:                    Win64
-- HeidiSQL version:             7.0.0.4053
-- Date/time:                    2013-01-14 23:55:09
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET FOREIGN_KEY_CHECKS=0 */;

-- Dumping database structure for mediterranium
CREATE DATABASE IF NOT EXISTS `mediterranium` /*!40100 DEFAULT CHARACTER SET utf8 */;
USE `mediterranium`;


-- Dumping structure for table mediterranium.categoria
CREATE TABLE IF NOT EXISTS `categoria` (
  `id_categoria` int(20) unsigned NOT NULL AUTO_INCREMENT,
  `nombre_categoria` varchar(20) NOT NULL,
  PRIMARY KEY (`id_categoria`),
  UNIQUE KEY `id_categoria` (`id_categoria`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.categoria_receta
CREATE TABLE IF NOT EXISTS `categoria_receta` (
  `id_receta` bigint(20) unsigned NOT NULL,
  `id_categoria` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`id_receta`,`id_categoria`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.favorito
CREATE TABLE IF NOT EXISTS `favorito` (
  `id_user` int(10) DEFAULT NULL,
  `id_receta` int(10) DEFAULT NULL,
  UNIQUE KEY `id_user_id_receta` (`id_user`,`id_receta`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.ingrediente
CREATE TABLE IF NOT EXISTS `ingrediente` (
  `nombre_ingrediente` varchar(20) NOT NULL,
  `id_ingrediente` int(20) unsigned NOT NULL AUTO_INCREMENT,
  `alta` char(1) DEFAULT NULL,
  PRIMARY KEY (`id_ingrediente`),
  UNIQUE KEY `id_ingrediente` (`id_ingrediente`),
  UNIQUE KEY `nombre_ingrediente` (`nombre_ingrediente`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.ingrediente_receta
CREATE TABLE IF NOT EXISTS `ingrediente_receta` (
  `id_ingrediente` bigint(20) unsigned NOT NULL,
  `id_receta` bigint(20) unsigned NOT NULL,
  `cantidad` int(11) NOT NULL,
  `id_unidad` int(11) NOT NULL,
  PRIMARY KEY (`id_ingrediente`,`id_receta`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.nacionalidad
CREATE TABLE IF NOT EXISTS `nacionalidad` (
  `id_nacionalidad` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `nombre_nacionalidad` varchar(10) NOT NULL,
  PRIMARY KEY (`id_nacionalidad`),
  UNIQUE KEY `id_nacionalidad` (`id_nacionalidad`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.paso
CREATE TABLE IF NOT EXISTS `paso` (
  `id_receta` bigint(20) unsigned NOT NULL,
  `numero_paso` int(11) NOT NULL,
  `paso` text NOT NULL,
  PRIMARY KEY (`id_receta`,`numero_paso`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.planificacion
CREATE TABLE IF NOT EXISTS `planificacion` (
  `fecha_planificacion` date NOT NULL,
  `id_usuario` int(20) unsigned NOT NULL,
  `id_planificacion` int(20) unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id_planificacion`),
  KEY `id_usuario` (`id_usuario`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.planificacion_receta
CREATE TABLE IF NOT EXISTS `planificacion_receta` (
  `id_receta` int(10) NOT NULL DEFAULT '0',
  `no_personas` int(10) DEFAULT NULL,
  `id_planificacion` int(10) NOT NULL DEFAULT '0',
  `id_planificacion_receta` int(10) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id_planificacion_receta`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.receta
CREATE TABLE IF NOT EXISTS `receta` (
  `id_receta` int(20) unsigned NOT NULL AUTO_INCREMENT,
  `image` blob NOT NULL,
  `MYME_type` varchar(10) NOT NULL,
  `id_nacionalidad` int(20) unsigned NOT NULL,
  `nombre_receta` varchar(30) NOT NULL,
  `no_personas` smallint(6) NOT NULL,
  `alta` varchar(1) DEFAULT '0',
  PRIMARY KEY (`id_receta`),
  UNIQUE KEY `id_receta` (`id_receta`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.rol
CREATE TABLE IF NOT EXISTS `rol` (
  `name_rol` varchar(10) NOT NULL,
  `id_rol` int(20) unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id_rol`),
  UNIQUE KEY `id_rol` (`id_rol`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.subcategoria
CREATE TABLE IF NOT EXISTS `subcategoria` (
  `id_subcategoria` int(10) NOT NULL AUTO_INCREMENT,
  `nombre_subcategoria` varchar(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_subcategoria`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.subcategoria_receta
CREATE TABLE IF NOT EXISTS `subcategoria_receta` (
  `id_subcategoria` int(10) NOT NULL DEFAULT '0',
  `id_receta` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_subcategoria`,`id_receta`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.unidad
CREATE TABLE IF NOT EXISTS `unidad` (
  `id_unidad` int(10) NOT NULL AUTO_INCREMENT,
  `nombre_unidad` varchar(50) DEFAULT '0',
  PRIMARY KEY (`id_unidad`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- Data exporting was unselected.


-- Dumping structure for table mediterranium.user
CREATE TABLE IF NOT EXISTS `user` (
  `id_user` int(20) unsigned NOT NULL AUTO_INCREMENT,
  `name_user` varchar(10) NOT NULL,
  `password` varchar(10) NOT NULL,
  `surname` varchar(10) NOT NULL,
  `id_rol` int(20) unsigned NOT NULL,
  `email` varchar(30) NOT NULL,
  PRIMARY KEY (`id_user`),
  UNIQUE KEY `id_usuario` (`id_user`),
  UNIQUE KEY `email` (`email`),
  KEY `id_rol` (`id_rol`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Data exporting was unselected.
/*!40014 SET FOREIGN_KEY_CHECKS=1 */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
