package com.mediterranium.planificacion;

import java.util.ArrayList;
import java.util.List;

import javax.ejb.Stateless;
import javax.persistence.Query;

import com.mediterranium.eao.EAOFactory;
import com.mediterranium.eao.EAOFactoryImpl;
import com.mediterranium.eao.PlanificacionEAO;
import com.mediterranium.eao.RecetaEAO;
import com.mediterranium.eao.UserEAO;
import com.mediterranium.entities.Planificacion;
import com.mediterranium.entities.Receta;
import com.mediterranium.entities.RecetaPlanificada;

@Stateless
public class PlanificacionFacadeBean implements IPlanificacionFacade {

	public void savePlanificacion(Planificacion planificacion){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	List<Receta> recetas = new ArrayList<Receta>();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	
    	for(RecetaPlanificada rp:planificacion.getRecetasPlanificadas()){
    		Receta receta ;
    		receta = recetaEAO.getRecetaMinima(rp.getReceta().getIdReceta());
    		rp.setReceta(receta);
    	}
    	
    	UserEAO userEAO = eaoFactory.getUserEAO();
    	planificacion.setUser(userEAO.getUser(planificacion.getUser().getEmail()));
    	
    	PlanificacionEAO planificacionEAO = eaoFactory.getPlanificacionEAO();
    	planificacionEAO.savePlanificacion(planificacion);
    	
    	
    }
}
