package com.mediterranium.user;

import java.util.List;

import javax.ejb.Remote;

import com.mediterranium.entities.Favorito;
import com.mediterranium.entities.User;

@Remote
public interface IUserFacade {
	
	/** Guarda un usuario con ril de usuario
	 * @param user
	 */
	public void saveUser(User user) ;
	
	
	/**
	 * Devuelve el usuario encontrado por e-mail
	 * @param user
	 * @return
	 */
	public User logUser(User user);
	/** Devuelve true si existe el e-mail y por lo tanto el usuario
	 * @param email
	 * @return
	 */
	public boolean existEmail(String email);
	
	/**
	 * Devuelve true si est bien el password
	 * @param user
	 * @return
	 */
	public boolean isPasswordOK(User user);
	
	/**
	 * Devuelve una lista de favoritos
	 * @return
	 */
	public List<Favorito> getFavoritos(int idUser);
	
	public void anadirFavorita(Favorito favorito);
	
	public void eliminarFavorita(Favorito favorito);
}
