package com.mediterranium.user;

import java.util.List;

import javax.ejb.Stateless;

import com.mediterranium.eao.EAOFactory;
import com.mediterranium.eao.EAOFactoryImpl;
import com.mediterranium.eao.UserEAO;
import com.mediterranium.entities.Favorito;
import com.mediterranium.entities.User;

/**
 * Session Bean implementation class UserFacadeBean
 */
@Stateless
public class UserFacadeBean implements IUserFacade {

    /**
     * Default constructor. 
     */
    public UserFacadeBean() {
        
    }

    public void saveUser(User user){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	UserEAO userEAO = eaoFactory.getUserEAO();
    	userEAO.saveUser(user);
    }
    
   
    public User logUser(User user){
    	User userAux;
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	UserEAO userEAO = eaoFactory.getUserEAO();
    	userAux = userEAO.getUser(user.getEmail());
    	return userAux;
    }
    
    public boolean existEmail(String email){
    	
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	UserEAO userEAO = eaoFactory.getUserEAO();
    	return userEAO.existEmail(email);
    }
    
    public boolean isPasswordOK(User user){
    	User userAux;
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	UserEAO userEAO = eaoFactory.getUserEAO();
    	userAux = userEAO.getUser(user.getEmail());
    	return userAux.getPassword().equals(user.getPassword());
    }
    
    public List<Favorito> getFavoritos(int idUser){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	UserEAO userEAO = eaoFactory.getUserEAO();
    	List<Favorito> favoritos = userEAO.getFavoritos(idUser);
    	return favoritos;
    }
    
    public void anadirFavorita(Favorito favorito){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	UserEAO userEAO = eaoFactory.getUserEAO();
    	userEAO.anadirFavorita(favorito);
    }
    
    public void eliminarFavorita(Favorito favorito){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	UserEAO userEAO = eaoFactory.getUserEAO();
    	userEAO.eliminarFavorita(favorito);
    }
}
