package com.metditerranium.receptes;

import java.util.List;

import javax.ejb.Stateless;

import com.mediterranium.eao.CategoriaEAO;
import com.mediterranium.eao.EAOFactory;
import com.mediterranium.eao.EAOFactoryImpl;
import com.mediterranium.eao.RecetaEAO;
import com.mediterranium.eao.UnidadEAO;
import com.mediterranium.entities.Categoria;
import com.mediterranium.entities.Ingrediente;
import com.mediterranium.entities.Nacionalidad;
import com.mediterranium.entities.Receta;
import com.mediterranium.entities.Unidad;

/**
 * Session Bean implementation class CategoriasFacadeBean
 */
@Stateless
public class ReceptesFacadeBean implements IReceptesFacade {

    /**
     * Default constructor. 
     */
    public ReceptesFacadeBean() {
       
    }
    public List<Categoria> getAllCategorias(){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	CategoriaEAO cat = eaoFactory.getCategoriaEAO();
    	return cat.getAllCategories();
    }
    
    public List<Nacionalidad> getAllNacionalidad(){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	CategoriaEAO cat = eaoFactory.getCategoriaEAO();
    	return cat.getAllNacionalidad();
    }
    
    
    public Receta getReceta(int idReceta){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO cat = eaoFactory.getRecetaEAO();
    	Receta receta = cat.getReceta(idReceta);
    	return receta;
    }
    
    public Receta getRecetaMinima(int id){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO cat = eaoFactory.getRecetaEAO();
    	Receta receta = cat.getRecetaMinima(id);
    	return receta;
    }
    
    public void saveReceta(Receta receta){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	recetaEAO.saveReceta(receta);
    }
    
    public List<Receta> getAllTraditionalRecipes(){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	return recetaEAO.getAllTraditionalRecipes();
    }
    
    public List<Receta> getAllEasyRecipes(){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	return recetaEAO.getAllEasyRecipes();
    }
    
    public List<Receta> getAllImpressiveRecipes(){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	return recetaEAO.getAllImpressiveRecipes();
    }
    
    public List<Receta> getAllCheapRecipes(){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	return recetaEAO.getAllCheapRecipes();
    }
    
    public List<Receta> getAllFastRecipes(){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	return recetaEAO.getAllFastRecipes();
    }
    
    public List<Receta> getAllRecipesAdvanced(Receta receta){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	return recetaEAO.getAllRecipesAdvanced(receta);
    }
    
    public List<Unidad> getAllUnits(){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	UnidadEAO unidadEAO = eaoFactory.getUnidadEAO();
    	return unidadEAO.getAllUnits();
    }
    
    public List<Receta> getReceptesTemporada(int temporada){
    	
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	return recetaEAO.getReceptesTemporada(temporada);
    }
    
    public List<Receta> getAllEditableRecipes() {
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	return recetaEAO.getAllEditableRecipes();
    }
    
    public List<Ingrediente> getAllEditableIngredientes(){
    	EAOFactory eaoFactory = new EAOFactoryImpl();
    	RecetaEAO recetaEAO = eaoFactory.getRecetaEAO();
    	return recetaEAO.getAllIngredientes();
    }

}
