package com.mediterranium.eao;

import java.util.Properties;

import javax.ejb.EJB;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class EAOFactoryImpl implements EAOFactory{
	private static final String PKG_INTERFACES = "org.jboss.ejb.client.naming";
	private Context initialContext;
	
//	@EJB
//	private UserEAO userEAO;

	public UserEAO getUserEAO() {
		
		UserEAO userEAO = null;

		try {
			if(initialContext==null)
				initialContext = getInitialContext();

			String lookupName = getLookupName(
					UserEAOBean.class.getSimpleName(), UserEAO.class.getName());

			userEAO = (UserEAO) initialContext.lookup(lookupName);
		} catch (NamingException e) {
			e.printStackTrace();
		}
		return userEAO;

	}
	
	public RecetaEAO getRecetaEAO(){
		RecetaEAO recetaEAO = null;

		try {
			if(initialContext==null)
				initialContext = getInitialContext();

			String lookupName = getLookupName(
					RecetaEAOBean.class.getSimpleName(), RecetaEAO.class.getName());

			recetaEAO = (RecetaEAO) initialContext.lookup(lookupName);
		} catch (NamingException e) {
			e.printStackTrace();
		}
		return recetaEAO;
	}
	
	public PlanificacionEAO getPlanificacionEAO(){
		PlanificacionEAO planificacionEAO = null;

		try {
			if(initialContext==null)
				initialContext = getInitialContext();

			String lookupName = getLookupName(
					PlanificacionEAOBean.class.getSimpleName(), PlanificacionEAO.class.getName());

			planificacionEAO = (PlanificacionEAO) initialContext.lookup(lookupName);
		} catch (NamingException e) {
			e.printStackTrace();
		}
		return planificacionEAO;
	}
	
	public CategoriaEAO getCategoriaEAO(){
		CategoriaEAO categoriaEAO = null;

		try {
			if(initialContext==null)
				initialContext = getInitialContext();

			String lookupName = getLookupName(
					CategoriaEAOBean.class.getSimpleName(), CategoriaEAO.class.getName());

			categoriaEAO = (CategoriaEAO) initialContext.lookup(lookupName);
		} catch (NamingException e) {
			e.printStackTrace();
		}
		return categoriaEAO;
	}
	
	public UnidadEAO getUnidadEAO(){
		UnidadEAO unidadEAO = null;

		try {
			if(initialContext==null)
				initialContext = getInitialContext();

			String lookupName = getLookupName(
					UnidadEAOBean.class.getSimpleName(), UnidadEAO.class.getName());

			unidadEAO = (UnidadEAO) initialContext.lookup(lookupName);
		} catch (NamingException e) {
			e.printStackTrace();
		}
		return unidadEAO;
	}

	private Context getInitialContext() throws NamingException {
		Context initialContext;
		Properties properties = new Properties();
		properties.put(Context.URL_PKG_PREFIXES, PKG_INTERFACES);

		return new InitialContext(properties);
	}

	private String getLookupName(String implClassName,
			String fullyQualifiedInterface) {
		/*
		 * The app name is the EAR name of the deployed EJB without .ear suffix.
		 * Since we haven't deployed the application as a .ear, the app name for
		 * us will be an empty string
		 */
		String appName = "ear-1.0-SNAPSHOT";

		/*
		 * The module name is the JAR name of the deployed EJB without the .jar
		 * suffix.
		 */
		String moduleName = "integration-1.0-SNAPSHOT";

		/*
		 * AS7 allows each deployment to have an (optional) distinct name. This
		 * can be an empty string if distinct name is not specified.
		 */
		String distinctName = "";

		// The EJB bean implementation class name
		String beanName = implClassName;

		// Fully qualified remote interface name
		final String interfaceName = fullyQualifiedInterface;

		// Create a look up string name
		String name = "ejb:" + appName + "/" + moduleName + "/" + distinctName
				+ "/" + beanName + "!" + interfaceName;
		return name;
	}
}
