package com.mediterranium.eao;

import java.util.ArrayList;
import java.util.List;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import utils.Constants;

import com.mediterranium.entities.Categoria;
import com.mediterranium.entities.Ingrediente;
import com.mediterranium.entities.IngredienteReceta;
import com.mediterranium.entities.Paso;
import com.mediterranium.entities.Receta;
import com.mediterranium.entities.Subcategoria;

@Stateless
public class RecetaEAOBean implements RecetaEAO {
	@PersistenceContext(unitName = "JPADB")
	private EntityManager entityManager;

	public void saveReceta(Receta receta) {
		// Query query =
		// entityManager.createNativeQuery("select * from nacionalidad  where id_nacionalidad = '"+receta.getNacionalidad().getIdNacionalidad()+"' ",Nacionalidad.class);
		// List<Nacionalidad> list = query.getResultList();
		// if(list.size()>0){
		// receta.setNacionalidad(list.get(0)) ;
		// }

		// Query query =
		// entityManager.createNativeQuery("select * from nacionalidad  where id_nacionalidad = '"+receta.get+"' ",Nacionalidad.class);
		// List<Nacionalidad> list = query.getResultList();
		// if(list.size()>0){
		// receta.setNacionalidad(list.get(0)) ;
		// }
		// receta.
		// String categorias ="";
		// for(Categoria cat:receta.getCategorias()){
		// categorias+=" id_categoria = "+cat.getIdCategoria()+" OR ";
		// }
		// categorias = categorias.substring(0, categorias.length()-4);
		// Query query =
		// entityManager.createNativeQuery("select * from categoria  where "+categorias,Categoria.class);
		// List<Categoria> list = query.getResultList();
		// receta.setCategorias(new ArrayList<Categoria>());
		// for(Categoria cat:list){
		// receta.getCategorias().add(cat) ;
		// }
		// receta.setNacionalidad(entityManager.getReference(Nacionalidad.class,
		// receta.getNacionalidad().getIdNacionalidad()));
		List<Categoria> categorias = new ArrayList<Categoria>();
		Categoria auxCat;
		for (Categoria cat : receta.getCategorias()) {
			auxCat = entityManager.find(Categoria.class, cat.getIdCategoria());
			categorias.add(auxCat);
		}
		receta.setCategorias(categorias);
		
		List<Subcategoria> subcategorias = new ArrayList<Subcategoria>();
		Subcategoria auxSubcat;
		if(receta.getSubcategorias()!=null){
			for (Subcategoria cat : receta.getSubcategorias()) {
				auxSubcat = entityManager.find(Subcategoria.class, cat.getIdSubcategoria());
				subcategorias.add(auxSubcat);
			}
			receta.setSubcategorias(subcategorias);
		}else{
			receta.setSubcategorias(null);
		}
		// Ingrediente ingrediente =
		// entityManager.getReference(Ingrediente.class, 1);
		// receta.setIngredientesReceta(new ArrayList<IngredienteReceta>());
		// receta.getIngredientesReceta().add(new IngredienteReceta());
		// receta.getIngredientesReceta().get(0).setIngrediente(ingrediente);
		// receta.setCategorias(null);
		List<IngredienteReceta> ingredientesReceta = receta
				.getIngredientesReceta();
		List<Paso> pasos = receta.getPasos();
		// for(IngredienteReceta ir:ingredientesReceta){
		// ir.setReceta(receta);
		// Query query =
		// entityManager.createNativeQuery("select * from ingrediente  where nombre_ingrediente = '"+ir.getIngrediente().getNombreIngrediente()+"'",Ingrediente.class);
		// List<Ingrediente> ingrediente = query.getResultList();
		// if(ingrediente.size()>0){
		// ir.setIngrediente(ingrediente.get(0));
		// }else{
		// entityManager.merge(ir.getIngrediente());
		// }
		//
		// }
		receta.setIngredientesReceta(null);
		// for(Paso p:receta.getPasos()){
		// p.setReceta(receta);
		// }

		receta.setPasos(null);
		entityManager.merge(receta);
		entityManager.flush();
		Query query = entityManager
				.createNativeQuery(
						"select * from receta  where id_receta = (select MAX(id_receta) from receta)",
						Receta.class);

		List<Receta> recetas = query.getResultList();
		if (recetas.size() > 0) {
			receta = recetas.get(0);
		}
		for (IngredienteReceta ir : ingredientesReceta) {
			ir.setReceta(receta);
			query = entityManager.createNativeQuery(
					"select * from ingrediente  where nombre_ingrediente = '"
							+ ir.getIngrediente().getNombreIngrediente() + "'",
					Ingrediente.class);
			List<Ingrediente> ingrediente = query.getResultList();
			if (ingrediente.size() == 0) {
				entityManager.merge(ir.getIngrediente());
				entityManager.flush();
				query = entityManager.createNativeQuery(
						"select * from ingrediente  where nombre_ingrediente = '"
								+ ir.getIngrediente().getNombreIngrediente()
								+ "'", Ingrediente.class);
				ingrediente = query.getResultList();
			}
			ir.setIngrediente(ingrediente.get(0));
			entityManager.merge(ir);
		}

		for (Paso p : pasos) {
			p.setReceta(receta);
			entityManager.merge(p);
		}

		// entityManager.persist(receta.getNacionalidad());
		// entityManager.persist(receta.getCategorias());
	}

	public Receta getReceta(int id) {
		Receta aux = null;
		Query query = entityManager.createNativeQuery(
				"select * from receta where receta.id_receta = " + id,
				Receta.class);
		List<Receta> list = query.getResultList();
		if (list.size() > 0) {
			aux = list.get(0);
			aux.getPasos().size();
			aux.getIngredientesReceta().size();
			aux.getCategorias().size();
		}
		return aux;
	}
	
	public Receta getRecetaMinima(int id) {
		Receta aux = null;
		Query query = entityManager.createNativeQuery(
				"select * from receta where receta.id_receta = " + id,
				Receta.class);
		List<Receta> list = query.getResultList();
		if (list.size() > 0) {
			aux = list.get(0);
			aux.getCategorias().size();
		}
		return aux;
	}

	public List<Receta> getAllTraditionalRecipes() {
		
		Query query = entityManager
				.createNativeQuery(
						"select * from receta join categoria_receta on receta.id_receta = categoria_receta.id_receta where categoria_receta.id_categoria = "
								+ Constants.CATEGORIA_TRADICIONAL+" and receta.alta = '1'", Receta.class);
		List<Receta> list = query.getResultList();
		for (Receta rec : list) {
			
			rec.getCategorias().size();
		}
		return list;
	}

	public List<Receta> getAllEasyRecipes() {
		
		Query query = entityManager
				.createNativeQuery(
						"select * from receta join categoria_receta on receta.id_receta = categoria_receta.id_receta where categoria_receta.id_categoria = "
								+ Constants.CATEGORIA_FACIL+" and receta.alta = '1'", Receta.class);
		List<Receta> list = query.getResultList();
		for (Receta rec : list) {
			
			rec.getCategorias().size();
		}
		return list;
	}

	public List<Receta> getAllImpressiveRecipes() {
		
		Query query = entityManager
				.createNativeQuery(
						"select * from receta join categoria_receta on receta.id_receta = categoria_receta.id_receta where categoria_receta.id_categoria = "
								+ Constants.CATEGORIA_IMPRESIONAR+" and receta.alta = '1'", Receta.class);
		List<Receta> list = query.getResultList();
		for (Receta rec : list) {
			
			rec.getCategorias().size();
		}
		return list;
	}
	
	public List<Receta> getAllEditableRecipes() {
		
		Query query = entityManager
				.createNativeQuery(
						"select * from receta where receta.alta = '0'", Receta.class);
		List<Receta> list = query.getResultList();
		for (Receta rec : list) {
			
			rec.getCategorias().size();
		}
		return list;
	}

	public List<Receta> getAllCheapRecipes() {
		
		Query query = entityManager
				.createNativeQuery(
						"select * from receta join categoria_receta on receta.id_receta = categoria_receta.id_receta where categoria_receta.id_categoria = "
								+ Constants.CATEGORIA_ECONOMICA+" and receta.alta = '1'", Receta.class);
		List<Receta> list = query.getResultList();
		for (Receta rec : list) {
			
			rec.getCategorias().size();
		}
		return list;
	}

	public List<Receta> getAllFastRecipes() {
		
		Query query = entityManager
				.createNativeQuery(
						"select * from receta join categoria_receta on receta.id_receta = categoria_receta.id_receta where categoria_receta.id_categoria = "
								+ Constants.CATEGORIA_RAPIDA+" and receta.alta = '1'", Receta.class);
		List<Receta> list = query.getResultList();
		for (Receta rec : list) {
			
			rec.getCategorias().size();
		}
		return list;
	}
	
	public List<Receta> getReceptesTemporada(int temporada){
		Query query = entityManager
				.createNativeQuery(
						"select * from receta join subcategoria_receta on receta.id_receta = subcategoria_receta.id_receta where subcategoria_receta.id_subcategoria = "
								+ temporada+" and receta.alta = '1'", Receta.class);
		List<Receta> list = query.getResultList();
		for (Receta rec : list) {
			
			rec.getCategorias().size();
		}
		return list;
	}
	
	public List<Receta> getAllRecipesAdvanced(Receta receta){
		String sql = "select * from receta join categoria_receta on receta.id_receta = categoria_receta.id_receta "+
				 " join ingrediente_receta on receta.id_receta = ingrediente_receta.id_receta "+
				 " join ingrediente on ingrediente.id_ingrediente = ingrediente_receta.id_ingrediente "+
				 " where receta.id_nacionalidad = "+receta.getNacionalidad().getIdNacionalidad();
		
		if(receta.getCategorias()!=null && receta.getCategorias().size()>0){
			sql += " AND categoria_receta.id_categoria = "+receta.getCategorias().get(0).getIdCategoria();
		}
		
		if(receta.getIngredientesReceta()!=null && receta.getIngredientesReceta().size()>0){
			sql += " AND ingrediente.nombre_ingrediente = '"+receta.getIngredientesReceta().get(0).getIngrediente().getNombreIngrediente()+"'";
		}
		
		sql+=" and receta.alta = '1'";
		
		Query query = entityManager
				.createNativeQuery(sql, Receta.class);
		List<Receta> list = query.getResultList();
		List<Receta> resultado =new ArrayList<Receta>();
		
		for(int i=0;i<list.size();i++){
			for(int j=i+1;j<list.size();j++){
				if(list.get(i).getIdReceta() == list.get(j).getIdReceta()){
					list.remove(j);
					j--;
				}
			}
		}
		
		for (Receta rec : list) {
			boolean unIngrediente=true;
			boolean unaCategoria=true;
			rec.getIngredientesReceta().size();
			rec.getCategorias().size();
			for(int i=0;i<receta.getIngredientesReceta().size()&& unIngrediente ;i++){
				unIngrediente=false;
				for(int j=0;j<rec.getIngredientesReceta().size();j++){
					if(rec.getIngredientesReceta().get(j).getIngrediente().getNombreIngrediente()
					.equals(receta.getIngredientesReceta().get(i).getIngrediente().getNombreIngrediente()))
						unIngrediente=true;
				}
			}
			
			for(int i=0;i<receta.getCategorias().size()&& unaCategoria ;i++){
				unaCategoria=false;
				for(int j=0;j<rec.getCategorias().size();j++){
					if(rec.getCategorias().get(j).getIdCategoria() ==
					receta.getCategorias().get(i).getIdCategoria())
						unaCategoria=true;
				}
			}
			if(unaCategoria && unIngrediente)
				resultado.add(rec);
			
		}
		
		
		return resultado;
	}
	
	public List<Ingrediente> getAllIngredientes(){
		Query query = entityManager
				.createNativeQuery(
						"select * from ingrediente where ingrediente.alta= '0'", Ingrediente.class);
		List<Ingrediente> list = query.getResultList();
		
		return list;
	}
}
