package com.mediterranium.eao;

import java.util.List;

import javax.ejb.Remote;

import com.mediterranium.entities.Favorito;
import com.mediterranium.entities.User;

@Remote
public interface UserEAO {
	/**Guarda un usuario como rol usuario
	 * @param user
	 */
	public void saveUser(User user) ;
	/**
	 * Obtiene un usuario a partir del e-mail
	 * @param email
	 * @return
	 */
	public User getUser(String email);
	/**
	 * Cierto si existe el usuario con dicho e-mail
	 * @param email
	 * @return
	 */
	public boolean existEmail(String email);
	
	
	/** 
	 * Obtiene las recetas favoritas de un usuario
	 * @param idUser user identifier
	 * @return Returns a list of User's favourit recipes
	 */
	public List<Favorito> getFavoritos(int idUser);
	
	public void anadirFavorita(Favorito favorito);
	
	public void eliminarFavorita(Favorito favorito);
}
