package com.mediterranium.eao;

import java.util.List;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import com.mediterranium.entities.Favorito;
import com.mediterranium.entities.FavoritoPK;
import com.mediterranium.entities.Receta;
import com.mediterranium.entities.Rol;
import com.mediterranium.entities.User;

/**
 * Session Bean implementation class UserDAOBean
 */
@Stateless
public class UserEAOBean implements UserEAO {
	@PersistenceContext(unitName = "JPADB")
	private EntityManager entityManager;

	public UserEAOBean() {

	}

	public void saveUser(User user) {
		// user.setIdRol(2);
		// TODO: set rol
		Rol rol = new Rol();
		rol.setIdRol(2);
		user.setRol(rol);
		entityManager.persist(user);
	}

	public User getUser(String email) {
		User userAux = null;
		Query query = entityManager.createNativeQuery(
				"select * from user  where email = '" + email + "' ",
				User.class);
		// +" left join rol on user.id_rol = rol.id_rol where email = '"+email+"' ",User.class);
		List<User> list = query.getResultList();
		if (list.size() > 0) {
			userAux = list.get(0);
		}
		return userAux;
	}

	public boolean existEmail(String email) {
		User user = getUser(email);
		return user == null ? false : true;
	}

	public List<Favorito> getFavoritos(int idUser) {
		User userAux=null;
		Query query = entityManager.createNativeQuery(
				"select * from user join favorito  where user.id_user = '" + idUser + "' ",
				User.class);
		// +" left join rol on user.id_rol = rol.id_rol where email = '"+email+"' ",User.class);
		List<User> list = (List<User>)query.getResultList();
		if (list.size() > 0) {
			userAux = list.get(0);
			userAux.getFavoritos().size();
			for(Favorito favorito:userAux.getFavoritos()){
				favorito.getReceta().getCategorias().size();
			}
		}
		
		return userAux!=null?userAux.getFavoritos():null;
	}
	
	public void anadirFavorita(Favorito favorito){
		Receta receta = entityManager.find(Receta.class,favorito.getReceta().getIdReceta());
		favorito.setReceta(receta);
		User user = entityManager.find(User.class,favorito.getUser().getIdUser());
		favorito.setUser(user);
		entityManager.merge(favorito);
	}
	
	public void eliminarFavorita(Favorito favorito){
		Receta receta = entityManager.find(Receta.class,favorito.getReceta().getIdReceta());
		favorito.setReceta(receta);
		User user = entityManager.find(User.class,favorito.getUser().getIdUser());
		favorito.setUser(user);
		FavoritoPK favoritoPK = new FavoritoPK();
		favoritoPK.setReceta(receta);
		favoritoPK.setUser(user);
		favorito = entityManager.find(Favorito.class, favoritoPK);
		entityManager.remove(favorito);
	}

}
