package com.mediterranium.entities;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="ingrediente_receta")
@IdClass(IngredienteRecetaPK.class)
public class IngredienteReceta implements Serializable{
	@Id
	@JoinColumn(name="id_ingrediente", referencedColumnName="id_ingrediente")
	@ManyToOne
	private Ingrediente ingrediente;
	
	@Id
	@JoinColumn(name="id_receta", referencedColumnName="id_receta")
	@ManyToOne
	private Receta receta;
	
	@JoinColumn(name="id_unidad", referencedColumnName="id_unidad")
	@ManyToOne
	private Unidad unidad;
	
	public Unidad getUnidad() {
		return unidad;
	}
	public void setUnidad(Unidad unidad) {
		this.unidad = unidad;
	}
	
	
	@Column(name="cantidad")
	private int cantidad;

	public Ingrediente getIngrediente() {
		return ingrediente;
	}

	public void setIngrediente(Ingrediente ingrediente) {
		this.ingrediente = ingrediente;
	}

	public Receta getReceta() {
		return receta;
	}

	public void setReceta(Receta receta) {
		this.receta = receta;
	}
	
	public int getCantidad() {
		return cantidad;
	}

	public void setCantidad(int cantidad) {
		this.cantidad = cantidad;
	}

	@Override
	public String toString() {
		return "IngredienteReceta [ingrediente=" + ingrediente + ", cantidad="
				+ cantidad + "]";
	}

	public IngredienteReceta() {
		super();
		ingrediente = new Ingrediente();
	}
	
	
	
}
