package com.mediterranium.entities;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="paso")
@IdClass(PasoPK.class)
public class Paso implements Serializable{
	@Id
	@JoinColumn(name="id_receta", referencedColumnName="id_receta")
	@ManyToOne(cascade=CascadeType.ALL)
	private Receta receta;
	
	@Id
	@Column(name="numero_paso")
	private int numeroPaso;
	
	@Lob
	private String paso;

	public Receta getReceta() {
		return receta;
	}

	public void setReceta(Receta receta) {
		this.receta = receta;
	}

	public int getNumeroPaso() {
		return numeroPaso;
	}

	public void setNumeroPaso(int numeroPaso) {
		this.numeroPaso = numeroPaso;
	}

	public String getPaso() {
		return paso;
	}

	public void setPaso(String paso) {
		this.paso = paso;
	}

	@Override
	public String toString() {
		return "Paso [paso=" + paso + "]";
	}
	
	

}
