package com.mediterranium.entities;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name="planificacion")
public class Planificacion implements Serializable {
	
	@Column(name = "fecha_planificacion")
	@Temporal(TemporalType.DATE)
	private Date fechaPlanificacion;
	
	@ManyToOne
	@JoinColumn(name="id_usuario", referencedColumnName="id_user")
	private User user;
	
	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name = "id_planificacion")
	private int idPlanificacion;
	
	@OneToMany(mappedBy="planificacion",cascade=CascadeType.ALL)
	private List<RecetaPlanificada>recetasPlanificadas;

	public Date getFechaPlanificacion() {
		return fechaPlanificacion;
	}

	public void setFechaPlanificacion(Date fechaPlanificacion) {
		this.fechaPlanificacion = fechaPlanificacion;
	}

	
	

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	public int getIdPlanificacion() {
		return idPlanificacion;
	}

	public void setIdPlanificacion(int idPlanificacion) {
		this.idPlanificacion = idPlanificacion;
	}

	public List<RecetaPlanificada> getRecetasPlanificadas() {
		return recetasPlanificadas;
	}

	public void setRecetasPlanificadas(List<RecetaPlanificada> recetasPlanificadas) {
		this.recetasPlanificadas = recetasPlanificadas;
	}
	
	
}
