package com.mediterranium.entities;

import java.io.Serializable; 
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.Lob;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Transient;

@Entity
@Table(name = "receta")
//@SecondaryTable(name="images")//,
//pkJoinColumns=@PrimaryKeyJoinColumn( name = "id_receta", referencedColumnName = "id_receta" ))
public class Receta implements Serializable{
	
	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name = "id_receta")
	private int idReceta;
	@JoinColumn(name="id_nacionalidad", referencedColumnName="id_nacionalidad")
	@ManyToOne
	private Nacionalidad nacionalidad;
	@Column(name = "nombre_receta")
	private String nombreReceta;
	@Column(name = "no_personas")
	private int noPersonas;
	
//	@Column(name = "no_personas")
//	private String noPersonas;
	@Column(name="MYME_type")
	private String MYMEType;
	
	@Transient
	private String urlImage;
	
	@Column(name="alta")
	private String alta;
	
	public String getAlta() {
		return alta;
	}
	public void setAlta(String alta) {
		this.alta = alta;
	}
	public String getUrlImage() {
		return urlImage;
	}
	public void setUrlImage(String urlImage) {
		this.urlImage = urlImage;
	}
	@Lob
	private byte[] image;
	
	
	@OneToMany(mappedBy="receta")//,cascade=CascadeType.ALL)
	private List<IngredienteReceta> ingredientesReceta;
	
	
	@OneToMany(mappedBy="receta",cascade=CascadeType.ALL)
	private List<Paso> pasos = new ArrayList<Paso>();
	
	@OneToMany(mappedBy="receta",cascade=CascadeType.ALL)
	private List<Favorito> favoritos= new ArrayList<Favorito>();
	
	
	@ManyToMany(cascade=CascadeType.ALL)
	  @JoinTable(name="categoria_receta", 
	    joinColumns=
	        @JoinColumn(name="id_receta", referencedColumnName="id_receta"),
	      inverseJoinColumns=
	      @JoinColumn(name="id_categoria", referencedColumnName="id_categoria")
	      )
	private List<Categoria> categorias;
	
	@ManyToMany(cascade=CascadeType.ALL)
	  @JoinTable(name="subcategoria_receta", 
	    joinColumns=
	        @JoinColumn(name="id_receta", referencedColumnName="id_receta"),
	      inverseJoinColumns=
	      @JoinColumn(name="id_subcategoria", referencedColumnName="id_subcategoria")
	      )
	private List<Subcategoria> subcategorias;
	
	
	
	public String getMYMEType() {
		return MYMEType;
	}
	public void setMYMEType(String mYMEType) {
		MYMEType = mYMEType;
	}
	public byte[] getImage() {
		return image;
	}
	public void setImage(byte[] image) {
		this.image = image;
	}
	public List<Categoria> getCategorias() {
		return categorias;
	}
	public void setCategorias(List<Categoria> categorias) {
		this.categorias = categorias;
	}
	public List<IngredienteReceta> getIngredientesReceta() {
		return ingredientesReceta;
	}
	public void setIngredientesReceta(List<IngredienteReceta> ingredientesReceta) {
		this.ingredientesReceta = ingredientesReceta;
	}
	public int getIdReceta() {
		return idReceta;
	}
	public void setIdReceta(int idReceta) {
		this.idReceta = idReceta;
	}
	public Nacionalidad getNacionalidad() {
		return nacionalidad;
	}
	public void setNacionalidad(Nacionalidad nacionalidad) {
		this.nacionalidad = nacionalidad;
	}
	
	
	public List<Favorito> getFavoritos() {
		return favoritos;
	}
	public void setFavoritos(List<Favorito> favoritos) {
		this.favoritos = favoritos;
	}
	public String getNombreReceta() {
		return nombreReceta;
	}
	public void setNombreReceta(String nombreReceta) {
		this.nombreReceta = nombreReceta;
	}
	public int getNoPersonas() {
		return noPersonas;
	}
	public void setNoPersonas(int noPersonas) {
		this.noPersonas = noPersonas;
	}
	

//	public String getNoPersonas() {
//		return noPersonas;
//	}
//	public void setNoPersonas(String noPersonas) {
//		this.noPersonas = noPersonas;
//	}
	
	
	public List<Paso> getPasos() {
		return pasos;
	}
	public void setPasos(List<Paso> pasos) {
		this.pasos = pasos;
	}
	
	
	
	
	public List<Subcategoria> getSubcategorias() {
		return subcategorias;
	}
	public void setSubcategorias(List<Subcategoria> subcategorias) {
		this.subcategorias = subcategorias;
	}
	@Override
	public String toString() {
		return "Receta [idReceta=" + idReceta + ", nacionalidad="
				+ nacionalidad + ", nombreReceta=" + nombreReceta
				+ ", noPersonas=" + noPersonas + ", MYMEType=" + MYMEType
//				+ ", image=" + Arrays.toString(image)
				 + ", ingredientesReceta="
				+ ingredientesReceta + ", pasos=" + pasos + ", categorias="
				+ categorias + "]";
	}
	public Receta() {
		super();
		ingredientesReceta = new ArrayList<IngredienteReceta>();
		nacionalidad = new Nacionalidad();
		categorias = new ArrayList<Categoria>();
	}
	
	
	
	
	
}
