package com.mediterranium.entities;

import java.io.Serializable;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity
@Table(name = "user")
public class User implements Serializable{

	@Id
	@Column(name = "id_user")
	private int idUser;
	
	@Column(name = "name_user")
	private String name;
	
	private String surname;
	private String email;
	private String password;
	
	@OneToMany(mappedBy="user",cascade=CascadeType.ALL)
	private List<Favorito>favoritos;
	
	
	@JoinColumn(name="id_rol", referencedColumnName="id_rol")
	@ManyToOne
	private Rol rol;

	public User() {
		super();
		
	}
	
	

	public List<Favorito> getFavoritos() {
		return favoritos;
	}



	public void setFavoritos(List<Favorito> favoritos) {
		this.favoritos = favoritos;
	}



	public Rol getRol() {
		return rol;
	}

	public void setRol(Rol rol) {
		this.rol = rol;
	}

	public int getIdUser() {
		return idUser;
	}

	public void setIdUser(int idUser) {
		this.idUser = idUser;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getSurname() {
		return surname;
	}

	public void setSurname(String surname) {
		this.surname = surname;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}


	@Override
	public String toString() {
		return "User [idUser=" + idUser + ", name=" + name + ", surname="
				+ surname + ", email=" + email + ", password=" + password + 
				", rol="+ rol+"]";
	}
	
	
	
}
