package utils;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

public class Utils {
	
	
	
	static public byte[] FileTOByteArray(File file) throws IOException{
		ByteArrayOutputStream ous = new ByteArrayOutputStream();
        InputStream ios = new FileInputStream(file);
	    

	    try {
	        byte []buffer = new byte[(int)file.length()];
	        
	        int read = 0;
	        while ( (read = ios.read(buffer)) != -1 ) {
	            ous.write(buffer, 0, read);
	        }
	    } finally { 
	        try {
	             if ( ous != null ) 
	                 ous.close();
	        } catch ( IOException e) {
	        }

	        try {
	             if ( ios != null ) 
	                  ios.close();
	        } catch ( IOException e) {
	        }
	    }
	    return ous.toByteArray();
	}
	
	public static boolean isNotEmpty(String cadena){
		return cadena != null && !cadena.equals("");
	}
	
	public static boolean isEmpty(String cadena){
		return cadena == null || cadena.equals("");
	}
	
	public static boolean isNotEmpty(List list){
		return list != null && list.size()>0;
	}
	
	public static int getSeason(Date day){
		Calendar calendar = GregorianCalendar.getInstance();
		calendar.setTime(day);
		
		//Spring starts:
		calendar.set(Calendar.MONTH, 2);
		calendar.set(Calendar.DAY_OF_MONTH, 21);
		Date spring_start = calendar.getTime();
		
		//summer starts
		calendar.set(Calendar.MONTH, 5);
		calendar.set(Calendar.DAY_OF_MONTH, 21);
		Date summer_start = calendar.getTime();
		
		//Autumn starts
		calendar.set(Calendar.MONTH, 8);
		calendar.set(Calendar.DAY_OF_MONTH, 23);
		Date autumn_start = calendar.getTime();
		
		//Winter starts
		calendar.set(Calendar.MONTH, 11);
		calendar.set(Calendar.DAY_OF_MONTH, 21);
		Date winter_start = calendar.getTime();
		
		int retorno;
		if(day.getTime()<spring_start.getTime()){
			retorno = Constants.SUBCATEGORIA_INVIERNO;
		}else if(day.getTime()< summer_start.getTime()){
			retorno = Constants.SUBCATEGORIA_PRIMAVERA;
		}else if (day.getTime()< autumn_start.getTime()){
			retorno = Constants.SUBCATEGORIA_VERANO;
		}else if (day.getTime()< winter_start.getTime()){
			retorno = Constants.SUBCATEGORIA_OTONO;
		}else{ retorno = Constants.SUBCATEGORIA_INVIERNO;}
		return retorno;
	}
	
	public static int getSeasonToday(){
		Calendar calendar = GregorianCalendar.getInstance();
		Date today = calendar.getTime();
		return getSeason(today);
	}

}
