package com.mediterranium.categoriasPublic;

import java.util.ArrayList;
import java.util.List;

import utils.Constants;

import com.mediterranium.entities.Ingrediente;
import com.mediterranium.entities.IngredienteReceta;
import com.mediterranium.entities.Receta;
import com.mediterranium.locator.EJBLocator;
import com.metditerranium.receptes.IReceptesFacade;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.Preparable;

public class BusquedaAvanzada  extends ActionSupport implements Preparable {
	private Receta receta;
	
	private String ingredientes;
	
	private int todos;
	
	private List<Receta> recetasAvanzada;
	
	
	
	
	public int getTodos() {
		return todos;
	}



	public void setTodos(int todos) {
		this.todos = todos;
	}



	public String getIngredientes() {
		return ingredientes;
	}



	public void setIngredientes(String ingredientes) {
		this.ingredientes = ingredientes;
	}



	public Receta getReceta() {
		return receta;
	}



	public void setReceta(Receta receta) {
		this.receta = receta;
	}



	public List<Receta> getRecetasAvanzada() {
		return recetasAvanzada;
	}



	public void setRecetasAvanzada(List<Receta> recetasAvanzada) {
		this.recetasAvanzada = recetasAvanzada;
	}
	
	public void prepare() throws Exception {
		
		String[]ingrs = ingredientes.split(" ");
		List<IngredienteReceta> ingredientesReceta= new ArrayList<IngredienteReceta>();
		
		for(String ingrediente:ingrs){
			if(!ingrediente.equals("")){
				Ingrediente ingr = new Ingrediente();
				ingr.setNombreIngrediente(ingrediente);
				IngredienteReceta ingrReceta = new IngredienteReceta();
				ingrReceta.setIngrediente(ingr);
				ingredientesReceta.add(ingrReceta);
			}
		}
		receta.setIngredientesReceta(ingredientesReceta);

		EJBLocator ejbLocator = EJBLocator
				.getInstanceReceptes(Constants.FACADE_RECETAS);
		IReceptesFacade iReceptesFacade = ejbLocator.getReceptesFacade();
		// iReceptesFacade.saveReceta(receta);
		recetasAvanzada = iReceptesFacade.getAllRecipesAdvanced(receta);

		for (Receta rec : recetasAvanzada) {
			rec.setUrlImage("data:" + rec.getMYMEType() + ";base64,"
					+ utils.Base64.encode(rec.getImage()));
		}

	}



	public String execute() {
		// you action logic
		return SUCCESS;
	}
}
