package com.mediterranium.categoriasPublic;

import java.util.ArrayList;
import java.util.List;

import utils.Constants;
import utils.Utils;

import com.mediterranium.entities.Receta;
import com.mediterranium.entities.Subcategoria;
import com.mediterranium.locator.EJBLocator;
import com.metditerranium.receptes.IReceptesFacade;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.Preparable;


public class CocinaTemporadaSeleccionada  extends ActionSupport implements Preparable{
	private List<Receta> recetasDeTemporada;
	
	private List<Subcategoria> subcategorias;
	
	private int temporada;
	
	public String execute() throws Exception {
		// Aqu se buscan las recetas de categoria cocinaTemporada
		
		String retorno="";
		if(temporada == Constants.SUBCATEGORIA_INVIERNO){
			retorno = Constants.WINTER;
		}else if(temporada == Constants.SUBCATEGORIA_OTONO){
			retorno = Constants.AUTUMN;
		}else if(temporada == Constants.SUBCATEGORIA_PRIMAVERA){
			retorno = Constants.SPRING;
		}else if(temporada == Constants.SUBCATEGORIA_VERANO){
			retorno = Constants.SUMMER;
		}
		return retorno; 
	}
	
	

	public int getTemporada() {
		return temporada;
	}



	public void setTemporada(int temporada) {
		this.temporada = temporada;
	}



	public List<Receta> getRecetasDeTemporada() {
		return recetasDeTemporada;
	}
	public void setRecetasDeTemporada(List<Receta> recetasDeTemporada) {
		this.recetasDeTemporada = recetasDeTemporada;
	}
	
	public List<Subcategoria> getSubcategorias() {
		return subcategorias;
	}

	public void setSubcategorias(List<Subcategoria> subcategorias) {
		this.subcategorias = subcategorias;
	}

	@Override
	public void prepare() throws Exception {
		// TODO Auto-generated method stub
		EJBLocator ejbLocator = EJBLocator
				.getInstanceReceptes(Constants.FACADE_RECETAS);
		IReceptesFacade iReceptesFacade = ejbLocator.getReceptesFacade();
		recetasDeTemporada = iReceptesFacade.getReceptesTemporada(temporada);
		
		subcategorias = new ArrayList<Subcategoria>();
		Subcategoria subcat = new Subcategoria();
		subcat.setIdSubcategoria(Constants.SUBCATEGORIA_INVIERNO);
		subcat.setNombreSubcategoria(getText("subcategoria.invierno"));
		subcategorias.add(subcat);
		
		subcat = new Subcategoria();
		subcat.setIdSubcategoria(Constants.SUBCATEGORIA_OTONO);
		subcat.setNombreSubcategoria(getText("subcategoria.otono"));
		subcategorias.add(subcat);
		
		subcat = new Subcategoria();
		subcat.setIdSubcategoria(Constants.SUBCATEGORIA_PRIMAVERA);
		subcat.setNombreSubcategoria(getText("subcategoria.primavera"));
		subcategorias.add(subcat);
		
		subcat = new Subcategoria();
		subcat.setIdSubcategoria(Constants.SUBCATEGORIA_VERANO);
		subcat.setNombreSubcategoria(getText("subcategoria.verano"));
		subcategorias.add(subcat);
		
		for (Receta rec : recetasDeTemporada) {
			rec.setUrlImage("data:" + rec.getMYMEType() + ";base64,"
					+ utils.Base64.encode(rec.getImage()));
		}
	}

}
