package com.mediterranium.common;

import java.util.List;
import java.util.Map;

import utils.Constants;

import com.mediterranium.entities.Categoria;
import com.mediterranium.entities.Nacionalidad;
import com.mediterranium.entities.Unidad;
import com.mediterranium.locator.EJBLocator;
import com.metditerranium.receptes.IReceptesFacade;
import com.opensymphony.xwork2.Action;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.Preparable;

public class PreparaNacionalidadesYCategorias extends ActionSupport implements Preparable {
	
	private List<Categoria> categorias;
	
	private List<Nacionalidad> nacionalidades;
	
	private List<Unidad> unidades;
	
	@SuppressWarnings("unchecked")
	public void prepare() throws Exception {
		List<Categoria> cat;
		
		
		@SuppressWarnings("rawtypes")
		Map session  = ActionContext.getContext().getSession();
		cat = (List<Categoria> )session.get(Constants.CATEGORIAS);
		if(cat==null){
		
			EJBLocator ejbLocator = EJBLocator.getInstanceReceptes(Constants.FACADE_RECETAS);
			IReceptesFacade iReceptesFacade = ejbLocator.getReceptesFacade();
			categorias= iReceptesFacade.getAllCategorias() ;
			nacionalidades = iReceptesFacade.getAllNacionalidad();
			unidades = iReceptesFacade.getAllUnits();
			session.put(Constants.CATEGORIAS, categorias);
			session.put(Constants.NACIONALIDADES, nacionalidades);
			session.put(Constants.UNIDADES, unidades);
		}else{
			categorias = cat;
			nacionalidades = (List<Nacionalidad> )session.get(Constants.NACIONALIDADES);
			unidades= (List<Unidad> )session.get(Constants.UNIDADES);
		}
    }
	
	
	
	public List<Unidad> getUnidades() {
		return unidades;
	}



	public void setUnidades(List<Unidad> unidades) {
		this.unidades = unidades;
	}



	public List<Nacionalidad> getNacionalidades() {
		return nacionalidades;
	}



	public void setNacionalidades(List<Nacionalidad> nacionalidades) {
		this.nacionalidades = nacionalidades;
	}



	public List<Categoria> getCategorias() {
		return categorias;
	}

	public void setCategorias(List<Categoria> categorias) {
		this.categorias = categorias;
	}
	
	public String execute() {
        
        return Action.SUCCESS;
    }

}
