package com.mediterranium.opcionesSecure;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

import utils.Constants;

import com.mediterranium.entities.Receta;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.Preparable;

public class AnadirRecetaPlanificada extends ActionSupport implements Preparable{

	private List<Receta> recetasSesion;
	private int numReceta;
	
	private String mes;
	private int dia;
	private int ano;
	
	private String prepareMes;
	private int prepareDia;
	private int prepareAno;
	
	
	
	public String getPrepareMes() {
		return prepareMes;
	}



	public void setPrepareMes(String prepareMes) {
		this.prepareMes = prepareMes;
	}



	public int getPrepareDia() {
		return prepareDia;
	}



	public void setPrepareDia(int prepareDia) {
		this.prepareDia = prepareDia;
	}



	public int getPrepareAno() {
		return prepareAno;
	}



	public void setPrepareAno(int prepareAno) {
		this.prepareAno = prepareAno;
	}



	public String getMes() {
		return mes;
	}

	

	public List<Receta> getRecetasSesion() {
		return recetasSesion;
	}



	public void setRecetasSesion(List<Receta> recetasSesion) {
		this.recetasSesion = recetasSesion;
	}



	public void setMes(String mes) {
		this.mes = mes;
	}


	public int getDia() {
		return dia;
	}


	public void setDia(int dia) {
		this.dia = dia;
	}


	public int getAno() {
		return ano;
	}


	public void setAno(int ano) {
		this.ano = ano;
	}


	public int getNumReceta() {
		return numReceta;
	}


	public void setNumReceta(int numReceta) {
		this.numReceta = numReceta;
	}


	@Override
	public void prepare() throws Exception {
		String retorno;
		boolean trobat=false;
		Date date = new Date();
		Calendar cal = Calendar.getInstance(getLocale());
		cal.setTime(date);
	    String formato="MMMM";
	    SimpleDateFormat dateFormat = new SimpleDateFormat(formato);
	    
	    while(!trobat){
	    	if(dateFormat.format(date).equals(mes)){
	    		trobat=true;
	    	}else
	    	cal.add(Calendar.MONTH, 1);
	    	date = cal.getTime();
	    }
	    
	    formato ="MM";
	    dateFormat = new SimpleDateFormat(formato);
	    int mesAux = Integer.parseInt(dateFormat.format(date));
	    
	    
	    cal.setTime(date);
	    
	    cal.set(Calendar.DAY_OF_MONTH, dia);
	    mesAux--;
	    cal.set(Calendar.MONTH, mesAux);
		cal.set(Calendar.YEAR, ano);
		cal.add(Calendar.DAY_OF_MONTH,numReceta-1);
		
		prepareDia= cal.get(Calendar.DAY_OF_MONTH);
		prepareAno = cal.get(Calendar.YEAR);
		
		formato="MMMM";
	    dateFormat = new SimpleDateFormat(formato);
	    prepareMes = dateFormat.format(date);
	    
	    Map session  = ActionContext.getContext().getSession();
		recetasSesion =(List<Receta>)session.get(Constants.RECETAS_SESSION);
		if(session.get(Constants.RECETAS_SESSION)==null){
			session.put(Constants.RECETAS_SESSION, new ArrayList<Receta>());
		}
		
		if(numReceta<8){
			retorno = SUCCESS;
		}else{
			retorno = Constants.EMPTY;
		}
	}

}
