package com.mediterranium.opcionesSecure;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Map;

import utils.Constants;

import com.mediterranium.entities.Planificacion;
import com.mediterranium.entities.User;
import com.mediterranium.locator.EJBLocator;
import com.mediterranium.planificacion.IPlanificacionFacade;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class GuardaPlanificacion extends ActionSupport {
	
	private String mes;
	
	private int dia;
	
	private int ano;
	
	private Planificacion planificacion;
	
	



	public Planificacion getPlanificacion() {
		return planificacion;
	}



	public void setPlanificacion(Planificacion planificacion) {
		this.planificacion = planificacion;
	}



	public String getMes() {
		return mes;
	}



	public void setMes(String mes) {
		this.mes = mes;
	}



	public int getDia() {
		return dia;
	}



	public void setDia(int dia) {
		this.dia = dia;
	}



	public int getAno() {
		return ano;
	}



	public void setAno(int ano) {
		this.ano = ano;
	}


	public String execute() throws Exception {
		
		EJBLocator ejbLocator = EJBLocator.getInstancePlanificacion(Constants.FACADE_PLANIFICACION);
		IPlanificacionFacade iPlanificacionFacade = ejbLocator.getPlanificacionFacade();
		
		Map session  = ActionContext.getContext().getSession();
		User user = (User)session.get(Constants.ROL_REGISTERED_USER);
		planificacion.setUser(user);
		
		boolean trobat = false;
		Date date = new Date();
		String format = "MMMM";
		SimpleDateFormat dateFormat = new SimpleDateFormat(format);
		Calendar cal = Calendar.getInstance();
		cal.setTime(date);
		int mesNum=0;
		
		while(!trobat){
			if(dateFormat.format(date).equals(mes)){
				trobat=true;
				dateFormat= new SimpleDateFormat("MM");
				mesNum = Integer.parseInt(dateFormat.format(date));
				mesNum--;
			}else{
				cal.add(Calendar.MONTH, 1);
				date = cal.getTime();
			}
		}
		
		
		cal.set(Calendar.DAY_OF_MONTH, dia);
		cal.set(Calendar.YEAR,ano);
		cal.set(Calendar.MONTH,mesNum);
		date = cal.getTime();
		planificacion.setFechaPlanificacion(date);
		
		iPlanificacionFacade.savePlanificacion(planificacion);
		
		return SUCCESS;
	}
}
