package com.mediterranium.opcionesSecure;


import java.io.File;

import utils.Constants;
import utils.Utils;

import com.mediterranium.entities.Categoria;
import com.mediterranium.entities.Ingrediente;
import com.mediterranium.entities.IngredienteReceta;
import com.mediterranium.entities.Receta;
import com.mediterranium.entities.User;
import com.mediterranium.locator.EJBLocator;
import com.metditerranium.receptes.IReceptesFacade;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;


public class RegistrarReceta extends ActionSupport implements ModelDriven<Receta>,UserAware {

	
	private Receta receta= new Receta();
	@Override
	public Receta getModel() {
		return receta;
		
	}
	
	private File userImage;
    private String userImageContentType;
    private String userImageFileName;
    
    private int temporada;
	
	public String execute() throws Exception {
		/*********************************/
		
		for(int i=0;i<receta.getIngredientesReceta().size();i++){
			Ingrediente ingrediente = receta.getIngredientesReceta().get(i).getIngrediente();
			ingrediente.setAlta("1");
		}
		
		receta.setAlta("1");
		
		receta.setImage(Utils.FileTOByteArray(userImage));
		receta.setMYMEType(userImageContentType);
		EJBLocator ejbLocator = EJBLocator.getInstanceReceptes(Constants.FACADE_RECETAS);
		IReceptesFacade iReceptesFacade = ejbLocator.getReceptesFacade();
		iReceptesFacade.saveReceta(receta);
//		iReceptesFacade.getReceta();
		/*********************************/
		return SUCCESS;
	}
	
	@Override
	public void validate() {
		
		
		if(null!=getModel().getIngredientesReceta() && getModel().getIngredientesReceta().size()>0){
			IngredienteReceta ir = (IngredienteReceta)getModel().getIngredientesReceta().get(0);
			if(ir.getIngrediente()!=null){
				if(ir.getIngrediente().getNombreIngrediente()==null){
					addFieldError("ingredientesReceta[0].ingrediente.nombreIngrediente", getText("ingresarReceta.validacion.ingredientesReceta.obligatorio"));
				}else if(ir.getCantidad()==0){
					addFieldError("ingredientesReceta[0].ingrediente.nombreIngrediente", getText("ingresarReceta.validacion.ingredientesReceta.obligatorio"));
					
				}
			}else{
				addFieldError("ingredientesReceta[0].ingrediente.nombreIngrediente", getText("ingresarReceta.validacion.ingredientesReceta.obligatorio"));
			}
		}else{
			addFieldError("ingredientesReceta[0].ingrediente.nombreIngrediente", getText("ingresarReceta.validacion.ingredientesReceta.obligatorio"));
		}
		
		if(Utils.isNotEmpty(getModel().getPasos())){
			if(Utils.isEmpty(getModel().getPasos().get(0).getPaso())){
				addFieldError("pasos", getText("ingresarReceta.validacion.paso.obligatorio"));
//				addFieldError("pasos[0].paso", getText("ingresarReceta.validacion.paso.obligatorio"));
			}
		}else{
			addFieldError("pasos", getText("ingresarReceta.validacion.paso.obligatorio"));
//			addFieldError("pasos[0].paso", getText("ingresarReceta.validacion.paso.obligatorio"));
		}
//		addFieldError("pasos[0].paso", getText("ingresarReceta.validacion.ingredientesReceta.obligatorio"));
		
		if(userImage!=null){
		double bytes = userImage.length();
		double kiloBytes = bytes /1024;
		double megaBytes = kiloBytes/1024;
			
			if(megaBytes > 1)
				addFieldError("userImage", getText("prelude.user.image.too.large"));
			if(kiloBytes < 15 )
				addFieldError("userImage", getText("prelude.user.image.too.little"));
		}else{
			addFieldError("userImage", getText("prelude.user.image.null"));
		}
		
		if(getModel().getCategorias()!=null && getModel().getCategorias().size()>0){
			Categoria cat = getModel().getCategorias().get(0);
			if(cat.getIdCategoria()==0){
				addFieldError("categorias.idCategoria", getText("ingresarReceta.validacion.idCategoria.obligatorio"));
			}
		}else{
			addFieldError("categorias.idCategoria", getText("ingresarReceta.validacion.idCategoria.obligatorio"));
		}
		
	}
	
	public File getUserImage() {
        return userImage;
    }
 
    public void setUserImage(File userImage) {
        this.userImage = userImage;
    }
 
    public String getUserImageContentType() {
        return userImageContentType;
    }
 
    public void setUserImageContentType(String userImageContentType) {
        this.userImageContentType = userImageContentType;
    }
 
    public String getUserImageFileName() {
        return userImageFileName;
    }
 
    public void setUserImageFileName(String userImageFileName) {
        this.userImageFileName = userImageFileName;
    }
    
    

	public int getTemporada() {
		return temporada;
	}

	public void setTemporada(int temporada) {
		this.temporada = temporada;
	}

	@Override
	public User getUser() {
		return (User) ActionContext.getContext().getSession().get(Constants.ROL_REGISTERED_USER);
	}

	@Override
	public void setUser(User user) {
		ActionContext.getContext().getSession().put(Constants.ROL_REGISTERED_USER,user);
		
	}
	
}
