package com.mediterranium.opcionesSecure;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import utils.Constants;

import com.mediterranium.entities.Favorito;
import com.mediterranium.entities.Receta;
import com.mediterranium.entities.User;
import com.mediterranium.locator.EJBLocator;
import com.mediterranium.user.IUserFacade;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.Preparable;

public class VerFavoritos extends ActionSupport  implements Preparable  {

	private List<Receta> recetasFavoritas;
	
	
	public List<Receta> getRecetasFavoritas() {
		return recetasFavoritas;
	}


	public void setRecetasFavoritas(List<Receta> recetasFavoritas) {
		this.recetasFavoritas = recetasFavoritas;
	}


	@Override
	public void prepare() throws Exception {
		Map session  = ActionContext.getContext().getSession();
		User user=(User)session.get(Constants.ROL_REGISTERED_USER);
		
		EJBLocator ejbLocator = EJBLocator.getInstanceUser("userFacade");
		IUserFacade iUserFacade = ejbLocator.getUserFacade();
		List<Favorito> favoritos = iUserFacade.getFavoritos(user.getIdUser());
		if (favoritos == null)favoritos = new ArrayList<Favorito>();

		recetasFavoritas = new ArrayList<Receta>();
		for (Favorito favorito : favoritos) {
			Receta rec = favorito.getReceta();
			rec.setUrlImage("data:" + rec.getMYMEType() + ";base64,"
					+ utils.Base64.encode(rec.getImage()));
			recetasFavoritas.add(rec);
		}
	}

}
