package com.mediterranium.usuarios;

import java.sql.PreparedStatement;
import java.util.Map;

import javax.naming.NamingException;

import org.apache.struts2.interceptor.SessionAware;

import utils.Constants;

import com.mediterranium.entities.User;
import com.mediterranium.locator.EJBLocator;
import com.mediterranium.user.IUserFacade;
import com.metditerranium.receptes.IReceptesFacade;
import com.opensymphony.xwork2.Action;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

public class LogIn extends ActionSupport implements ModelDriven<User>{
	private User user = new User();


	public User getModel() {
		return user;
	}

	@SuppressWarnings("unchecked")
	@Override
	public String execute() throws Exception {
		
		User userAux;
		EJBLocator ejbLocator = EJBLocator.getInstanceUser("userFacade");
		IUserFacade iUserFacade = ejbLocator.getUserFacade();
		
		userAux = iUserFacade.logUser(user);
		if(userAux==null){
			return INPUT;
		}else{
			Map session  = ActionContext.getContext().getSession();
			session.put(Constants.ROL_REGISTERED_USER, userAux);
			return Action.SUCCESS;
		}
		
		
	}

	@Override
	public void validate() {
		try {
			EJBLocator ejbLocator = EJBLocator.getInstanceUser("userFacade");
			IUserFacade iUserFacade = ejbLocator.getUserFacade();
			if (!iUserFacade.existEmail(user.getEmail())) {
				addFieldError("email", getText("el.usuario.no.existe"));
			}else if(getModel().getPassword()!=null){
				if(!iUserFacade.isPasswordOK(getModel()))
					addFieldError("password", getText("el.password.es.incorrecto"));
			}else{
				addFieldError("email", getText("el.usuario.no.existe"));
			}

		} catch (NamingException e) {
			e.printStackTrace();
		}
	}


}
