package com.mediterranium.usuarios;

import javax.ejb.EJB;

import com.mediterranium.entities.User;
import com.mediterranium.locator.EJBLocator;
import com.mediterranium.user.IUserFacade;
import com.opensymphony.xwork2.Action;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

public class Registro extends ActionSupport implements ModelDriven<User> {
	/**
	 * 
	 */
	private static final long serialVersionUID = 9137267706951781730L;

	@Override
	public String execute() throws Exception {
		
		EJBLocator ejbLocator = EJBLocator.getInstanceUser("userFacade");
		IUserFacade iUserFacade = ejbLocator.getUserFacade();
		iUserFacade.saveUser(user);
		

		return Action.SUCCESS;
	}
	
	@Override
	public void validate() {
		try {
			EJBLocator ejbLocator = EJBLocator.getInstanceUser("userFacade");
			IUserFacade iUserFacade = ejbLocator.getUserFacade();
			if(iUserFacade.existEmail(user.getEmail())){
				 addFieldError("email",getText("el.email.ya.existe"));
				 addFieldError("reEmail",getText("el.email.ya.existe"));
			}
				 
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private User user = new User();

	public User getModel() {
		return user;
	}

	private String rePassword;
	private String reEmail;

	public String getRePassword() {
		return rePassword;
	}

	public void setRePassword(String rePassword) {
		this.rePassword = rePassword;
	}

	public String getReEmail() {
		return reEmail;
	}

	public void setReEmail(String reEmail) {
		this.reEmail = reEmail;
	}

	

}
